#include "w5500_initcode.h"
#include "stm32f4xx_hal.h"
#include "stm32f4xx.h"
#include "w5500.h"
#include "main.h"
#include "spi.h"
#include "usart.h"
#include "gpio.h"
#include "socket.h"

extern SPI_HandleTypeDef hspi2;
extern wiz_NetInfo gWIZNETINFO;

static uint32_t randomKey;


uint8_t W5500_dataRead() // SPI  
{
	uint8_t Dummy = 0xFF;
	uint8_t RxData;
	while (HAL_SPI_GetState(&hspi2) != HAL_SPI_STATE_READY);
	HAL_SPI_TransmitReceive(&hspi2,&Dummy,&RxData,1,10); // SPI Ž ̵͸  Ŭ ǰ ̺갡  ش.
	return RxData;
}
void W5500_dataSend(uint8_t Txdata) // SPI  ۽
{
	 while (HAL_SPI_GetState(&hspi2) != HAL_SPI_STATE_READY);
	 HAL_SPI_Transmit(&hspi2, (uint8_t *) &Txdata, 1, 10);
}

void W5500_CS_select()
{
	HAL_GPIO_WritePin(GPIOB, W5500_CS_Pin, GPIO_PIN_RESET); // CS Low
}

void W5500_CS_deselect()
{
	HAL_GPIO_WritePin(GPIOB, W5500_CS_Pin, GPIO_PIN_SET); // CS High
}

int isLinked(void)
{
	return (getPHYCFGR() & PHYCFGR_LNK_ON);
}

void W5500_hw_Rst(void) // ϵ 
{
  uint32_t tempTick;
  GPIOB->BSRR = W5500_RST_Pin; // RST  Low 
  tempTick = HAL_GetTick();
  while((HAL_GetTick() - tempTick) < 1 ); // 1ms  
  GPIOB->BSRR = W5500_RST_Pin; // RST  High .
}

void W5500_info()
{
	wizchip_getnetinfo(&gWIZNETINFO); // W5500   
}

uint8_t W5500_init() // ʱȭ Լ
{
	uint8_t W5500SockBufSize[2][8] = {{2,2,2,2,2,2,2,2},{2,2,2,2,2,2,2,2}};
	uint32_t tickStart;

	reg_wizchip_spi_cbfunc(W5500_dataRead, W5500_dataSend); // SPI  , ۽ ɵ (ݹԼ)
	reg_wizchip_cs_cbfunc(W5500_CS_select, W5500_CS_deselect); // CS   ɵ (ݹԼ)

	if(ctlwizchip(CW_INIT_WIZCHIP,(void*)W5500SockBufSize) == -1)
		{
			//printf("W5500 initialized fail.\r\n");
			return -1; // ʱȭ 
		}
		/*Set network information by default*/
		wizchip_setnetinfo(&gWIZNETINFO);
		tickStart = HAL_GetTick();
		do{ // PHY üũ
			randomKey++;
			if((HAL_GetTick() - tickStart) > 3000 )
			{
				//printf("Ethernet Link timeout.\r\n");
				return -1; // ̴ ŸӾƿ 
			}
		}while(!isLinked());
		return 1;
}


